Attribute VB_Name = "DSModule"
'------------------------------------------------------------------------
' DirectSound Module pour 3D / for 3D (beta version for Explosion Example)
'------------------------------------------------------------------------
'
' Sylvain Dupont @ December 1999.
'
'
' Le coin des dveloppeurs de Jeux 3D    http://francis.dupont.free.fr/coindev/
' The corner of developers of games 3D   http://francis.dupont.free.fr/coindev/english/
'
Const NDSB = 2

Public DS As DirectSound
Public DSB(1 To NDSB) As DirectSoundBuffer
Public DSB3D(1 To NDSB) As DirectSound3DBuffer
Public DSListener3D As DirectSound3DListener
Public DSPrimary As DirectSoundBuffer

Public Desc As DSBUFFERDESC
Public WF As WAVEFORMATEX

Public buffer(1 To NDSB) As Boolean
Sub DSPlay(numbuffer)
 DSB(numbuffer).Play DSBPLAY_DEFAULT
End Sub

Sub DSStop(numbuffer)
 DSB(numbuffer).Stop
End Sub

Sub InitDS()
 Set DS = DirectX.DirectSoundCreate("")
 DS.SetCooperativeLevel Form1.hWnd, DSSCL_NORMAL
 Desc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER
 Set DSPrimary = DS.CreateSoundBuffer(Desc, WF)
 Set DSListener3D = DSPrimary.GetDirectSound3DListener()
 DSListener3D.SetVelocity 0, 0, 0, DS3D_IMMEDIATE
 DSListener3D.SetPosition 0, 0, 0, DS3D_IMMEDIATE
 DSListener3D.SetDopplerFactor 1, DS3D_IMMEDIATE
 DSListener3D.SetOrientation 0, 0, 1, 0, 1, 0, DS3D_IMMEDIATE
 
 DSPrimary.Play DSBPLAY_LOOPING
End Sub


Function LoadWave(filename) As Integer
 For i = 1 To NDSB
  If buffer(i) <> True Then Exit For
 Next i
  numbuffer = i
    Desc.lFlags = (DSBCAPS_CTRL3D Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
  Set DSB(numbuffer) = DS.CreateSoundBufferFromFile(filename, Desc, WF)
  buffer(numbuffer) = True
  LoadWave = numbuffer
  Set DSB3D(numbuffer) = DSB(numbuffer).GetDirectSound3DBuffer
End Function


Sub SetListenerOrientation(x As Single, y As Single, z As Single, xt As Single, yt As Single, zt As Single)
 DSListener3D.SetOrientation x, y, z, xt, yt, zy, DS3D_IMMEDIATE
End Sub

Sub SetListenerPosition(x As Single, y As Single, z As Single)
 DSListener3D.SetPosition x, y, z, DS3D_IMMEDIATE
End Sub
Sub SetPosition(buffer As Integer, x As Single, y As Single, z As Single)
 DSB3D(buffer).SetPosition x, y, z, DS3D_IMMEDIATE
End Sub

Sub UninitDS()
 For i = 1 To NDSB
  Set DSB(i) = Nothing
  Set DSB3D(i) = Nothing
 Next i
 DS.SetCooperativeLevel Form1.hWnd, DSSCL_NORMAL
 Set DS = Nothing
End Sub


